<?php declare(strict_types=1);

namespace App\Repository;

use App\Entity\ItemExtra;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<ItemExtra>
 *
 * @method ItemExtra|null find($id, $lockMode = null, $lockVersion = null)
 * @method ItemExtra|null findOneBy(array $criteria, array $orderBy = null)
 * @method ItemExtra[]    findAll()
 * @method ItemExtra[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class ItemExtraRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, ItemExtra::class);
    }

    public function getUniqueNames(): Collection
    {
        $qb = $this->createQueryBuilder('p');

        $qb->groupBy('p.name');

        return new ArrayCollection($qb->getQuery()->getResult());
    }
}
